/*
 * Copyright (c) 2015-2017, Texas Instruments Incorporated
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * *  Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * *  Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * *  Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 *  ======== empty.c ========
 */
/* For usleep() */
#include <unistd.h>
#include <stdint.h>
#include <stddef.h>

/* Driver Header files */
#include <ti/drivers/GPIO.h>
// #include <ti/drivers/I2C.h>
// #include <ti/drivers/SDSPI.h>
// #include <ti/drivers/SPI.h>
// #include <ti/drivers/UART.h>
// #include <ti/drivers/Watchdog.h>

/* Board Header file */
#include "Board.h"


//------------------------------------------
#include <ti/drivers/UART.h>
UART_Handle uart;






//-----------------------------cc1310 nڲflashʹ-----------------------------------------

/*cc1310flashÿβд붼page 4kΪλġ
 * flashĵַΪ 0x00000000-0x000020000,Ҳ128k
 * ǰһЩַųˣҪдflash
 * Ҫܿ򲿷֡ĵַš
*/
#include <ti\devices\cc26x0\driverlib\flash.c>
uint8_t buff1[8] = {0xee,0xff,0xaa,0x55,0x00,0x00};
uint8_t buff[8] = {0xaa,0xbb,0xcc,0xcc,0x00,0xee};

#define ID_Flash_Addr  0x1e000

void ReadFlash(uint32_t wAddr,uint8_t *bBuf,uint8_t bLen)
{
    uint8_t *Flash_Ptr = (uint8_t *) wAddr;
    while(bLen--)
       *(bBuf++)=*(Flash_Ptr++);
}
//-----------------------------cc1310 nڲflashʹ-----------------------------------------





/*
 *  ======== mainThread ========
 */
void *mainThread(void *arg0)
{
    /* 1 second delay */
    uint32_t time = 1;

    /* Call driver init functions */
    GPIO_init();
    // I2C_init();
    // SDSPI_init();
    // SPI_init();
    // UART_init();
    // Watchdog_init();







    //---------------------------------------------------------------
        /*
         * UARTʹ÷
         * 1 UART_init();ǰͷļŶ
         * 2UART_Params_init(&uartParams);
         * 3޸uartĲĶʾ
         * 4UART_open(Board_UART0, &uartParams);uart.
         * 5ȻͿʹUART_write(uart, &aa1, sizeof(aa1));
         * */

        UART_Params uartParams;
        UART_init();
        UART_Params_init(&uartParams);
        uartParams.writeDataMode    = UART_DATA_BINARY;
        uartParams.readDataMode     = UART_DATA_BINARY;
        uartParams.readReturnMode   = UART_RETURN_FULL;
        uartParams.readEcho         = UART_ECHO_OFF;
        uartParams.baudRate         = 115200;
        uart = UART_open(Board_UART0, &uartParams);
    //---------------------------------------------------------------










    //-----------------------------cc1310 nڲflashʹ-----------------------------------------
    //flash Ĳд붼page4KΪλģͬһpageǿ϶ݸǵ
    //000000------0x001f000
    FlashSectorErase(ID_Flash_Addr);        //ĳһ
    FlashProgram(buff, ID_Flash_Addr, 8);   //дȥ
    ReadFlash(ID_Flash_Addr,buff1,8);       //
    UART_write(uart, &buff1, sizeof(buff1));//16ƶȡ
    //-----------------------------cc1310 nڲflashʹ-----------------------------------------











    while (1)
    {
        sleep(time);
        GPIO_toggle(Board_GPIO_LED0);
    }
}
